/*
 * This file was generated automatically by ExtUtils::ParseXS version 2.18_02 from the
 * contents of Estraier.xs. Do not edit this file, edit Estraier.xs instead.
 *
 *	ANY CHANGES MADE HERE WILL BE LOST! 
 *
 */

#line 1 "Estraier.xs"
/*************************************************************************************************
 * Perl binding of Hyper Estraier
 *                                                      Copyright (C) 2004-2005 Mikio Hirabayashi
 * This file is part of Hyper Estraier.
 * Hyper Estraier is free software; you can redistribute it and/or modify it under the terms of
 * the GNU Lesser General Public License as published by the Free Software Foundation; either
 * version 2.1 of the License or any later version.  Hyper Estraier is distributed in the hope
 * that it will be useful, but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU Lesser General Public
 * License for more details.
 * You should have received a copy of the GNU Lesser General Public License along with Hyper
 * Estraier; if not, write to the Free Software Foundation, Inc., 59 Temple Place, Suite 330,
 * Boston, MA 02111-1307 USA.
 *************************************************************************************************/


#include "EXTERN.h"
#include "perl.h"
#include "XSUB.h"
#include <estraier.h>
#include <estmtdb.h>
#include <cabin.h>
#include <stdlib.h>



/*************************************************************************************************
 * private objects
 *************************************************************************************************/


static AV *cblisttoav(const CBLIST *values);
static CBLIST *avtocblist(AV *av);
static HV *cbmaptohv(CBMAP *kwords);
static CBMAP *hvtocbmap(HV *hv);
static void dbinform(const char *message, void *opaque);


static AV *cblisttoav(const CBLIST *values){
  AV *av;
  const char *buf;
  int i, size;
  av = newAV();
  for(i = 0; i < cblistnum(values); i++){
    buf = cblistval(values, i, &size);
    av_push(av, newSVpvn(buf, size));
  }
  return av;
}


static CBLIST *avtocblist(AV *av){
  CBLIST *list;
  SV *val;
  STRLEN size;
  char *buf;
  int i, num;
  list = cblistopen();
  if((num = av_len(av)) < 0) return list;
  for(i = 0; i <= num; i++){
    val = *av_fetch(av, i, 0);
    buf = SvPV(val, size);
    cblistpush(list, buf, (int)size);
  }
  return list;
}


static HV *cbmaptohv(CBMAP *map){
  HV *hv;
  const char *kbuf, *vbuf;
  int ksiz, vsiz;
  hv = newHV();
  cbmapiterinit(map);
  while((kbuf = cbmapiternext(map, &ksiz)) != NULL){
    vbuf = cbmapiterval(kbuf, &vsiz);
    hv_store(hv, kbuf, ksiz, newSVpvn(vbuf, vsiz), 0);
  }
  return hv;
}


static CBMAP *hvtocbmap(HV *hv){
  HE *entry;
  STRLEN vsiz;
  CBMAP *map;
  char *kbuf, *vbuf;
  SV *val;
  I32 ksiz;
  map = cbmapopenex(31);
  hv_iterinit(hv);
  while((entry = hv_iternext(hv)) != NULL){
    kbuf = hv_iterkey(entry, &ksiz);
    val = hv_iterval(hv, entry);
    vbuf = SvPV(val, vsiz);
    cbmapput(map, kbuf, (int)ksiz, vbuf, (int)vsiz, FALSE);
  }
  return map;
}


static void dbinform(const char *message, void *opaque){
  dSP;
  ENTER;
  SAVETMPS;
  PUSHMARK(SP);
  XPUSHs(sv_2mortal(newSVpv(message, 0)));
  PUTBACK;
  perl_call_pv(opaque, G_DISCARD | G_EVAL);
  FREETMPS;
  LEAVE;
}



/*************************************************************************************************
 * public objects
 *************************************************************************************************/


#ifndef PERL_UNUSED_VAR
#  define PERL_UNUSED_VAR(var) if (0) var = var
#endif

#line 135 "Estraier.c"

XS(XS_Estraier_doc_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_new", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	RETVAL;
	dXSTARG;
#line 128 "Estraier.xs"
	RETVAL = est_doc_new();
#line 153 "Estraier.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_Estraier_doc_new_from_draft); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_new_from_draft)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_new_from_draft", "draft");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	char *	draft = (char *)SvPV_nolen(ST(0));
	void *	RETVAL;
	dXSTARG;
#line 137 "Estraier.xs"
	RETVAL = est_doc_new_from_draft(draft);
#line 177 "Estraier.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_Estraier_doc_delete); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_delete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_delete", "doc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	doc = INT2PTR(void *,SvIV(ST(0)));
#line 146 "Estraier.xs"
	est_doc_delete(doc);
#line 199 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_doc_add_attr); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_add_attr)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_add_attr", "doc, name, value");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	doc = INT2PTR(void *,SvIV(ST(0)));
	char *	name = (char *)SvPV_nolen(ST(1));
	char *	value = (char *)SvPV_nolen(ST(2));
#line 155 "Estraier.xs"
	if(!strcmp(value, "\t(NULL)\t")) value = NULL;
	est_doc_add_attr(doc, name, value);
#line 223 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_doc_add_text); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_add_text)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_add_text", "doc, text");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	doc = INT2PTR(void *,SvIV(ST(0)));
	char *	text = (char *)SvPV_nolen(ST(1));
#line 164 "Estraier.xs"
	est_doc_add_text(doc, text);
#line 245 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_doc_add_hidden_text); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_add_hidden_text)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_add_hidden_text", "doc, text");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	doc = INT2PTR(void *,SvIV(ST(0)));
	char *	text = (char *)SvPV_nolen(ST(1));
#line 172 "Estraier.xs"
	est_doc_add_hidden_text(doc, text);
#line 267 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_doc_set_keywords); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_set_keywords)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_set_keywords", "doc, kwords");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	doc = INT2PTR(void *,SvIV(ST(0)));
	HV *	kwords;
#line 180 "Estraier.xs"
	CBMAP *tkwords;
#line 289 "Estraier.c"

	if (SvROK(ST(1)) && SvTYPE(SvRV(ST(1)))==SVt_PVHV)
	    kwords = (HV*)SvRV(ST(1));
	else
	    Perl_croak(aTHX_ "%s: %s is not a hash reference",
			"Estraier::doc_set_keywords",
			"kwords");
#line 182 "Estraier.xs"
	tkwords = hvtocbmap(kwords);
	est_doc_set_keywords(doc, tkwords);
	cbmapclose(tkwords);
#line 301 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_doc_set_score); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_set_score)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_set_score", "doc, score");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	doc = INT2PTR(void *,SvIV(ST(0)));
	int	score = (int)SvIV(ST(1));
#line 192 "Estraier.xs"
	est_doc_set_score(doc, score);
#line 323 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_doc_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_id", "doc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	doc = INT2PTR(void *,SvIV(ST(0)));
	int	RETVAL;
	dXSTARG;
#line 199 "Estraier.xs"
	RETVAL = est_doc_id(doc);
#line 346 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_doc_attr_names); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_attr_names)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_attr_names", "doc");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	doc = INT2PTR(void *,SvIV(ST(0)));
#line 208 "Estraier.xs"
	CBLIST *names;
#line 370 "Estraier.c"
#line 210 "Estraier.xs"
	names = est_doc_attr_names(doc);
	XPUSHs(sv_2mortal(newRV_noinc((SV *)cblisttoav(names))));
	cblistclose(names);
	XSRETURN(1);
#line 376 "Estraier.c"
	PUTBACK;
	return;
    }
}


XS(XS_Estraier_doc_attr); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_attr)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_attr", "doc, name");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	doc = INT2PTR(void *,SvIV(ST(0)));
	char *	name = (char *)SvPV_nolen(ST(1));
	const char *	RETVAL;
	dXSTARG;
#line 221 "Estraier.xs"
	RETVAL = est_doc_attr(doc, name);
#line 401 "Estraier.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Estraier_doc_texts); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_texts)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_texts", "doc");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	doc = INT2PTR(void *,SvIV(ST(0)));
#line 230 "Estraier.xs"
	const CBLIST *texts;
#line 425 "Estraier.c"
#line 232 "Estraier.xs"
	texts = est_doc_texts(doc);
	XPUSHs(sv_2mortal(newRV_noinc((SV *)cblisttoav(texts))));
	XSRETURN(1);
#line 430 "Estraier.c"
	PUTBACK;
	return;
    }
}


XS(XS_Estraier_doc_cat_texts); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_cat_texts)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_cat_texts", "doc");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	doc = INT2PTR(void *,SvIV(ST(0)));
#line 241 "Estraier.xs"
	char *texts;
#line 454 "Estraier.c"
#line 243 "Estraier.xs"
	texts = est_doc_cat_texts(doc);
	XPUSHs(sv_2mortal(newSVpv(texts, 0)));
	free(texts);
	XSRETURN(1);
#line 460 "Estraier.c"
	PUTBACK;
	return;
    }
}


XS(XS_Estraier_doc_keywords); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_keywords)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_keywords", "doc");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	doc = INT2PTR(void *,SvIV(ST(0)));
#line 253 "Estraier.xs"
	CBMAP *kwords;
#line 484 "Estraier.c"
#line 255 "Estraier.xs"
	if((kwords = est_doc_keywords(doc)) != NULL){
	  XPUSHs(sv_2mortal(newRV_noinc((SV *)cbmaptohv(kwords))));
	} else {
	  XPUSHs((SV *)&PL_sv_undef);
	}
	XSRETURN(1);
#line 492 "Estraier.c"
	PUTBACK;
	return;
    }
}


XS(XS_Estraier_doc_score); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_score)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_score", "doc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	doc = INT2PTR(void *,SvIV(ST(0)));
	int	RETVAL;
	dXSTARG;
#line 267 "Estraier.xs"
	RETVAL = est_doc_score(doc);
#line 516 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_doc_make_snippet); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_make_snippet)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_make_snippet", "doc, words, wwidth, hwidth, awidth");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	doc = INT2PTR(void *,SvIV(ST(0)));
	AV *	words;
	int	wwidth = (int)SvIV(ST(2));
	int	hwidth = (int)SvIV(ST(3));
	int	awidth = (int)SvIV(ST(4));
#line 280 "Estraier.xs"
	CBLIST *twords;
	char *snippet;
#line 545 "Estraier.c"

	if (SvROK(ST(1)) && SvTYPE(SvRV(ST(1)))==SVt_PVAV)
	    words = (AV*)SvRV(ST(1));
	else
	    Perl_croak(aTHX_ "%s: %s is not an array reference",
			"Estraier::doc_make_snippet",
			"words");
#line 283 "Estraier.xs"
	twords = avtocblist(words);
	snippet = est_doc_make_snippet(doc, twords, wwidth, hwidth, awidth);
	XPUSHs(sv_2mortal(newSVpv(snippet, 0)));
	free(snippet);
	cblistclose(twords);
	XSRETURN(1);
#line 560 "Estraier.c"
	PUTBACK;
	return;
    }
}


XS(XS_Estraier_doc_dump_draft); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_doc_dump_draft)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::doc_dump_draft", "doc");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	doc = INT2PTR(void *,SvIV(ST(0)));
#line 295 "Estraier.xs"
	char *draft;
#line 584 "Estraier.c"
#line 297 "Estraier.xs"
	draft = est_doc_dump_draft(doc);
	XPUSHs(sv_2mortal(newSVpv(draft, 0)));
	free(draft);
	XSRETURN(1);
#line 590 "Estraier.c"
	PUTBACK;
	return;
    }
}


XS(XS_Estraier_cond_new); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_cond_new)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::cond_new", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
#line 306 "Estraier.xs"
	void *cond;
#line 611 "Estraier.c"
	void *	RETVAL;
	dXSTARG;
#line 308 "Estraier.xs"
	cond = est_cond_new();
	est_cond_set_options(cond, ESTCONDSCFB);
	RETVAL = cond;
#line 618 "Estraier.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_Estraier_cond_delete); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_cond_delete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::cond_delete", "cond");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	cond = INT2PTR(void *,SvIV(ST(0)));
#line 319 "Estraier.xs"
	est_cond_delete(cond);
#line 640 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_cond_set_phrase); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_cond_set_phrase)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::cond_set_phrase", "cond, phrase");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	cond = INT2PTR(void *,SvIV(ST(0)));
	char *	phrase = (char *)SvPV_nolen(ST(1));
#line 327 "Estraier.xs"
	est_cond_set_phrase(cond, phrase);
#line 662 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_cond_add_attr); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_cond_add_attr)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::cond_add_attr", "cond, expr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	cond = INT2PTR(void *,SvIV(ST(0)));
	char *	expr = (char *)SvPV_nolen(ST(1));
#line 335 "Estraier.xs"
	est_cond_add_attr(cond, expr);
#line 684 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_cond_set_order); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_cond_set_order)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::cond_set_order", "cond, expr");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	cond = INT2PTR(void *,SvIV(ST(0)));
	char *	expr = (char *)SvPV_nolen(ST(1));
#line 343 "Estraier.xs"
	est_cond_set_order(cond, expr);
#line 706 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_cond_set_max); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_cond_set_max)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::cond_set_max", "cond, max");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	cond = INT2PTR(void *,SvIV(ST(0)));
	int	max = (int)SvIV(ST(1));
#line 351 "Estraier.xs"
	est_cond_set_max(cond, max);
#line 728 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_cond_set_skip); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_cond_set_skip)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::cond_set_skip", "cond, skip");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	cond = INT2PTR(void *,SvIV(ST(0)));
	int	skip = (int)SvIV(ST(1));
#line 359 "Estraier.xs"
	est_cond_set_skip(cond, skip);
#line 750 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_cond_set_options); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_cond_set_options)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::cond_set_options", "cond, options");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	cond = INT2PTR(void *,SvIV(ST(0)));
	int	options = (int)SvIV(ST(1));
#line 367 "Estraier.xs"
	est_cond_set_options(cond, options);
#line 772 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_cond_set_auxiliary); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_cond_set_auxiliary)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::cond_set_auxiliary", "cond, min");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	cond = INT2PTR(void *,SvIV(ST(0)));
	int	min = (int)SvIV(ST(1));
#line 375 "Estraier.xs"
	est_cond_set_auxiliary(cond, min);
#line 794 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_cond_set_eclipse); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_cond_set_eclipse)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::cond_set_eclipse", "cond, limit");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	cond = INT2PTR(void *,SvIV(ST(0)));
	double	limit = (double)SvNV(ST(1));
#line 383 "Estraier.xs"
	est_cond_set_eclipse(cond, limit);
#line 816 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_cond_set_distinct); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_cond_set_distinct)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::cond_set_distinct", "cond, name");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	cond = INT2PTR(void *,SvIV(ST(0)));
	char *	name = (char *)SvPV_nolen(ST(1));
#line 391 "Estraier.xs"
	est_cond_set_distinct(cond, name);
#line 838 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_res_delete); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_res_delete)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 4)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::res_delete", "resptr, idxsptr, hints, cond");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	resptr = INT2PTR(void *,SvIV(ST(0)));
	void *	idxsptr = INT2PTR(void *,SvIV(ST(1)));
	void *	hints = INT2PTR(void *,SvIV(ST(2)));
	void *	cond = INT2PTR(void *,SvIV(ST(3)));
#line 401 "Estraier.xs"
	est_cond_delete(cond);
	cbmapclose(hints);
	free(idxsptr);
	free(resptr);
#line 865 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_res_get_doc_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_res_get_doc_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::res_get_doc_id", "resptr, index");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	resptr = INT2PTR(void *,SvIV(ST(0)));
	int	index = (int)SvIV(ST(1));
	int	RETVAL;
	dXSTARG;
#line 412 "Estraier.xs"
	RETVAL = ((int *)resptr)[index];
#line 889 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_res_get_dbidx); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_res_get_dbidx)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::res_get_dbidx", "idxsptr, index");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	idxsptr = INT2PTR(void *,SvIV(ST(0)));
	int	index = (int)SvIV(ST(1));
	int	RETVAL;
	dXSTARG;
#line 422 "Estraier.xs"
	RETVAL = ((int *)idxsptr)[index];
#line 914 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_res_hint_words); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_res_hint_words)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::res_hint_words", "hints");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	hints = INT2PTR(void *,SvIV(ST(0)));
#line 431 "Estraier.xs"
	CBLIST *words;
	const char *vbuf;
	int i;
#line 940 "Estraier.c"
#line 435 "Estraier.xs"
	words = cbmapkeys(hints);
	for(i = 0; i < cblistnum(words); i++){
	  vbuf = cblistval(words, i, NULL);
	  if(vbuf[0] == '\0'){
	    free(cblistremove(words, i, NULL));
	    break;
	  }
	}
	XPUSHs(sv_2mortal(newRV_noinc((SV *)cblisttoav(words))));
	cblistclose(words);
	XSRETURN(1);
#line 953 "Estraier.c"
	PUTBACK;
	return;
    }
}


XS(XS_Estraier_res_hint); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_res_hint)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::res_hint", "hints, word");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	hints = INT2PTR(void *,SvIV(ST(0)));
	char *	word = (char *)SvPV_nolen(ST(1));
#line 453 "Estraier.xs"
	const char *value;
#line 976 "Estraier.c"
	int	RETVAL;
	dXSTARG;
#line 455 "Estraier.xs"
	value = cbmapget(hints, word, -1, NULL);
	RETVAL = value ? atoi(value) : 0;
#line 982 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_res_get_score); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_res_get_score)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::res_get_score", "cond, index");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	cond = INT2PTR(void *,SvIV(ST(0)));
	int	index = (int)SvIV(ST(1));
	int	RETVAL;
	dXSTARG;
#line 466 "Estraier.xs"
	RETVAL = est_cond_score(cond, index);
#line 1007 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_res_get_shadows); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_res_get_shadows)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::res_get_shadows", "cond, id");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	cond = INT2PTR(void *,SvIV(ST(0)));
	int	id = (int)SvIV(ST(1));
#line 476 "Estraier.xs"
	const int *ary;
	int i, anum;
	AV *av;
#line 1034 "Estraier.c"
#line 480 "Estraier.xs"
	ary = est_cond_shadows(cond, id, &anum);
	av = newAV();
	for(i = 0; i < anum; i++){
	  av_push(av, newSViv(ary[i]));
	}
	XPUSHs(sv_2mortal(newRV_noinc((SV *)av)));
	XSRETURN(1);
#line 1043 "Estraier.c"
	PUTBACK;
	return;
    }
}


XS(XS_Estraier_db_version); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_version)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 0)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_version", "");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	const char *	RETVAL;
	dXSTARG;
#line 492 "Estraier.xs"
	RETVAL = est_version;
#line 1066 "Estraier.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_search_meta); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_search_meta)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_search_meta", "dbav, cond");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	AV *	dbav;
	void *	cond = INT2PTR(void *,SvIV(ST(1)));
#line 502 "Estraier.xs"
	ESTMTDB **dbs;
	CBMAP *hints;
	int i, dbnum, *res, rnum, *idxs;
#line 1093 "Estraier.c"

	if (SvROK(ST(0)) && SvTYPE(SvRV(ST(0)))==SVt_PVAV)
	    dbav = (AV*)SvRV(ST(0));
	else
	    Perl_croak(aTHX_ "%s: %s is not an array reference",
			"Estraier::db_search_meta",
			"dbav");
#line 506 "Estraier.xs"
	dbnum = av_len(dbav) + 1;
	dbs = cbmalloc(dbnum * sizeof(ESTMTDB *) + 1);
	for(i = 0; i < dbnum; i++){
	  dbs[i] = (ESTMTDB *)SvIV(*av_fetch(dbav, i, 0));
	}
	hints = cbmapopenex(31);
	res = est_mtdb_search_meta(dbs, dbnum, cond, &rnum, hints);
	idxs = cbmalloc(rnum / 2 * sizeof(int) + 1);
	for(i = 0; i < rnum; i += 2){
	  idxs[i/2] = res[i];
	  res[i/2] = res[i+1];
	}
	free(dbs);
	XPUSHs(sv_2mortal(newSViv((IV)res)));
	XPUSHs(sv_2mortal(newSViv((IV)idxs)));
	XPUSHs(sv_2mortal(newSViv((IV)(rnum / 2))));
	XPUSHs(sv_2mortal(newSViv((IV)hints)));
	XPUSHs(sv_2mortal(newSViv((IV)est_cond_dup(cond))));
	XSRETURN(5);
#line 1121 "Estraier.c"
	PUTBACK;
	return;
    }
}


XS(XS_Estraier_db_err_msg); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_err_msg)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_err_msg", "ecode");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	int	ecode = (int)SvIV(ST(0));
	const char *	RETVAL;
	dXSTARG;
#line 531 "Estraier.xs"
	RETVAL = est_err_msg(ecode);
#line 1145 "Estraier.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_open); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_open)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_open", "name, omode");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	char *	name = (char *)SvPV_nolen(ST(0));
	int	omode = (int)SvIV(ST(1));
#line 541 "Estraier.xs"
	void *	db;
	int	ecode;
#line 1171 "Estraier.c"
#line 544 "Estraier.xs"
	db = est_mtdb_open(name, omode, &ecode);
	XPUSHs(sv_2mortal(newSViv((IV)db)));
	XPUSHs(sv_2mortal(newSViv((IV)ecode)));
	XSRETURN(2);
#line 1177 "Estraier.c"
	PUTBACK;
	return;
    }
}


XS(XS_Estraier_db_close); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_close)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_close", "db");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
#line 554 "Estraier.xs"
	int ecode, rv;
#line 1201 "Estraier.c"
#line 556 "Estraier.xs"
	rv = est_mtdb_close(db, &ecode);
	XPUSHs(sv_2mortal(newSViv((IV)rv)));
	XPUSHs(sv_2mortal(newSViv((IV)ecode)));
	XSRETURN(2);
#line 1207 "Estraier.c"
	PUTBACK;
	return;
    }
}


XS(XS_Estraier_db_error); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_error)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_error", "db");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	int	RETVAL;
	dXSTARG;
#line 566 "Estraier.xs"
	RETVAL = est_mtdb_error(db);
#line 1231 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_fatal); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_fatal)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_fatal", "db");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	int	RETVAL;
	dXSTARG;
#line 575 "Estraier.xs"
	RETVAL = est_mtdb_fatal(db);
#line 1255 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_add_attr_index); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_add_attr_index)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_add_attr_index", "db, name, type");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	char *	name = (char *)SvPV_nolen(ST(1));
	int	type = (int)SvIV(ST(2));
	int	RETVAL;
	dXSTARG;
#line 586 "Estraier.xs"
	RETVAL = est_mtdb_add_attr_index(db, name, type);
#line 1281 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_flush); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_flush)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_flush", "db, max");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	int	max = (int)SvIV(ST(1));
	int	RETVAL;
	dXSTARG;
#line 596 "Estraier.xs"
	RETVAL = est_mtdb_flush(db, max);
#line 1306 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_sync); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_sync)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_sync", "db");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	int	RETVAL;
	dXSTARG;
#line 605 "Estraier.xs"
	RETVAL = est_mtdb_sync(db);
#line 1330 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_optimize); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_optimize)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_optimize", "db, options");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	int	options = (int)SvIV(ST(1));
	int	RETVAL;
	dXSTARG;
#line 615 "Estraier.xs"
	RETVAL = est_mtdb_optimize(db, options);
#line 1355 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_merge); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_merge)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_merge", "db, name, options");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	char *	name = (char *)SvPV_nolen(ST(1));
	int	options = (int)SvIV(ST(2));
	int	RETVAL;
	dXSTARG;
#line 626 "Estraier.xs"
	RETVAL = est_mtdb_merge(db, name, options);
#line 1381 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_put_doc); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_put_doc)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_put_doc", "db, doc, options");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	void *	doc = INT2PTR(void *,SvIV(ST(1)));
	int	options = (int)SvIV(ST(2));
	int	RETVAL;
	dXSTARG;
#line 637 "Estraier.xs"
	RETVAL = est_mtdb_put_doc(db, doc, options);
#line 1407 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_out_doc); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_out_doc)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_out_doc", "db, id, options");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	int	id = (int)SvIV(ST(1));
	int	options = (int)SvIV(ST(2));
	int	RETVAL;
	dXSTARG;
#line 648 "Estraier.xs"
	RETVAL = est_mtdb_out_doc(db, id, options);
#line 1433 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_edit_doc); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_edit_doc)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_edit_doc", "db, doc");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	void *	doc = INT2PTR(void *,SvIV(ST(1)));
	int	RETVAL;
	dXSTARG;
#line 658 "Estraier.xs"
	RETVAL = est_mtdb_edit_doc(db, doc);
#line 1458 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_get_doc); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_get_doc)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_get_doc", "db, id, options");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	int	id = (int)SvIV(ST(1));
	int	options = (int)SvIV(ST(2));
	void *	RETVAL;
	dXSTARG;
#line 669 "Estraier.xs"
	RETVAL = est_mtdb_get_doc(db, id, options);
#line 1484 "Estraier.c"
	XSprePUSH; PUSHi(PTR2IV(RETVAL));
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_get_doc_attr); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_get_doc_attr)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_get_doc_attr", "db, id, name");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	int	id = (int)SvIV(ST(1));
	char *	name = (char *)SvPV_nolen(ST(2));
#line 680 "Estraier.xs"
	char *value;
#line 1510 "Estraier.c"
#line 682 "Estraier.xs"
	value = est_mtdb_get_doc_attr(db, id, name);
	if(!value) XSRETURN_UNDEF;
	XPUSHs(sv_2mortal(newSVpv(value, 0)));
	free(value);
	XSRETURN(1);
#line 1517 "Estraier.c"
	PUTBACK;
	return;
    }
}


XS(XS_Estraier_db_uri_to_id); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_uri_to_id)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_uri_to_id", "db, uri");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	char *	uri = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;
#line 694 "Estraier.xs"
	RETVAL = est_mtdb_uri_to_id(db, uri);
#line 1542 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_name); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_name)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_name", "db");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	const char *	RETVAL;
	dXSTARG;
#line 703 "Estraier.xs"
	RETVAL = est_mtdb_name(db);
#line 1566 "Estraier.c"
	sv_setpv(TARG, RETVAL); XSprePUSH; PUSHTARG;
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_doc_num); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_doc_num)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_doc_num", "db");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	int	RETVAL;
	dXSTARG;
#line 712 "Estraier.xs"
	RETVAL = est_mtdb_doc_num(db);
#line 1590 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_word_num); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_word_num)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_word_num", "db");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	int	RETVAL;
	dXSTARG;
#line 721 "Estraier.xs"
	RETVAL = est_mtdb_word_num(db);
#line 1614 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_size)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 1)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_size", "db");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	double	RETVAL;
	dXSTARG;
#line 730 "Estraier.xs"
	RETVAL = est_mtdb_size(db);
#line 1638 "Estraier.c"
	XSprePUSH; PUSHn((double)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_search); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_search)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_search", "db, cond");
    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(ax); /* -Wall */
    SP -= items;
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	void *	cond = INT2PTR(void *,SvIV(ST(1)));
#line 740 "Estraier.xs"
	CBMAP *hints;
	int *res;
	int rnum;
#line 1665 "Estraier.c"
#line 744 "Estraier.xs"
	hints = cbmapopenex(31);
	res = est_mtdb_search(db, cond, &rnum, hints);
	XPUSHs(sv_2mortal(newSViv((IV)res)));
	XPUSHs(sv_2mortal(newSViv((IV)rnum)));
	XPUSHs(sv_2mortal(newSViv((IV)hints)));
	XPUSHs(sv_2mortal(newSViv((IV)est_cond_dup(cond))));
	XSRETURN(4);
#line 1674 "Estraier.c"
	PUTBACK;
	return;
    }
}


XS(XS_Estraier_db_scan_doc); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_scan_doc)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 3)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_scan_doc", "db, doc, cond");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	void *	doc = INT2PTR(void *,SvIV(ST(1)));
	void *	cond = INT2PTR(void *,SvIV(ST(2)));
	int	RETVAL;
	dXSTARG;
#line 759 "Estraier.xs"
	RETVAL = est_mtdb_scan_doc(db, doc, cond);
#line 1700 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_set_cache_size); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_set_cache_size)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 5)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_set_cache_size", "db, size, anum, tnum, rnum");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	double	size = (double)SvNV(ST(1));
	int	anum = (int)SvIV(ST(2));
	int	tnum = (int)SvIV(ST(3));
	int	rnum = (int)SvIV(ST(4));
#line 772 "Estraier.xs"
	est_mtdb_set_cache_size(db, (size_t)size, anum, tnum, rnum);
#line 1726 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_db_add_pseudo_index); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_add_pseudo_index)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_add_pseudo_index", "db, path");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	char *	path = (char *)SvPV_nolen(ST(1));
	int	RETVAL;
	dXSTARG;
#line 780 "Estraier.xs"
	RETVAL = est_mtdb_add_pseudo_index(db, path);
#line 1750 "Estraier.c"
	XSprePUSH; PUSHi((IV)RETVAL);
    }
    XSRETURN(1);
}


XS(XS_Estraier_db_set_wildmax); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_set_wildmax)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_set_wildmax", "db, num");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	int	num = (int)SvIV(ST(1));
#line 790 "Estraier.xs"
	est_mtdb_set_wildmax(db, num);
#line 1773 "Estraier.c"
    }
    XSRETURN_EMPTY;
}


XS(XS_Estraier_db_set_informer); /* prototype to pass -Wmissing-prototypes */
XS(XS_Estraier_db_set_informer)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    if (items != 2)
       Perl_croak(aTHX_ "Usage: %s(%s)", "Estraier::db_set_informer", "db, informer");
    PERL_UNUSED_VAR(cv); /* -W */
    {
	void *	db = INT2PTR(void *,SvIV(ST(0)));
	char *	informer = (char *)SvPV_nolen(ST(1));
#line 798 "Estraier.xs"
	est_mtdb_set_informer(db, dbinform, informer);
#line 1795 "Estraier.c"
    }
    XSRETURN_EMPTY;
}

#ifdef __cplusplus
extern "C"
#endif
XS(boot_Estraier); /* prototype to pass -Wmissing-prototypes */
XS(boot_Estraier)
{
#ifdef dVAR
    dVAR; dXSARGS;
#else
    dXSARGS;
#endif
    char* file = __FILE__;

    PERL_UNUSED_VAR(cv); /* -W */
    PERL_UNUSED_VAR(items); /* -W */
    XS_VERSION_BOOTCHECK ;

        newXS("Estraier::doc_new", XS_Estraier_doc_new, file);
        newXS("Estraier::doc_new_from_draft", XS_Estraier_doc_new_from_draft, file);
        newXS("Estraier::doc_delete", XS_Estraier_doc_delete, file);
        newXS("Estraier::doc_add_attr", XS_Estraier_doc_add_attr, file);
        newXS("Estraier::doc_add_text", XS_Estraier_doc_add_text, file);
        newXS("Estraier::doc_add_hidden_text", XS_Estraier_doc_add_hidden_text, file);
        newXS("Estraier::doc_set_keywords", XS_Estraier_doc_set_keywords, file);
        newXS("Estraier::doc_set_score", XS_Estraier_doc_set_score, file);
        newXS("Estraier::doc_id", XS_Estraier_doc_id, file);
        newXS("Estraier::doc_attr_names", XS_Estraier_doc_attr_names, file);
        newXS("Estraier::doc_attr", XS_Estraier_doc_attr, file);
        newXS("Estraier::doc_texts", XS_Estraier_doc_texts, file);
        newXS("Estraier::doc_cat_texts", XS_Estraier_doc_cat_texts, file);
        newXS("Estraier::doc_keywords", XS_Estraier_doc_keywords, file);
        newXS("Estraier::doc_score", XS_Estraier_doc_score, file);
        newXS("Estraier::doc_make_snippet", XS_Estraier_doc_make_snippet, file);
        newXS("Estraier::doc_dump_draft", XS_Estraier_doc_dump_draft, file);
        newXS("Estraier::cond_new", XS_Estraier_cond_new, file);
        newXS("Estraier::cond_delete", XS_Estraier_cond_delete, file);
        newXS("Estraier::cond_set_phrase", XS_Estraier_cond_set_phrase, file);
        newXS("Estraier::cond_add_attr", XS_Estraier_cond_add_attr, file);
        newXS("Estraier::cond_set_order", XS_Estraier_cond_set_order, file);
        newXS("Estraier::cond_set_max", XS_Estraier_cond_set_max, file);
        newXS("Estraier::cond_set_skip", XS_Estraier_cond_set_skip, file);
        newXS("Estraier::cond_set_options", XS_Estraier_cond_set_options, file);
        newXS("Estraier::cond_set_auxiliary", XS_Estraier_cond_set_auxiliary, file);
        newXS("Estraier::cond_set_eclipse", XS_Estraier_cond_set_eclipse, file);
        newXS("Estraier::cond_set_distinct", XS_Estraier_cond_set_distinct, file);
        newXS("Estraier::res_delete", XS_Estraier_res_delete, file);
        newXS("Estraier::res_get_doc_id", XS_Estraier_res_get_doc_id, file);
        newXS("Estraier::res_get_dbidx", XS_Estraier_res_get_dbidx, file);
        newXS("Estraier::res_hint_words", XS_Estraier_res_hint_words, file);
        newXS("Estraier::res_hint", XS_Estraier_res_hint, file);
        newXS("Estraier::res_get_score", XS_Estraier_res_get_score, file);
        newXS("Estraier::res_get_shadows", XS_Estraier_res_get_shadows, file);
        newXS("Estraier::db_version", XS_Estraier_db_version, file);
        newXS("Estraier::db_search_meta", XS_Estraier_db_search_meta, file);
        newXS("Estraier::db_err_msg", XS_Estraier_db_err_msg, file);
        newXS("Estraier::db_open", XS_Estraier_db_open, file);
        newXS("Estraier::db_close", XS_Estraier_db_close, file);
        newXS("Estraier::db_error", XS_Estraier_db_error, file);
        newXS("Estraier::db_fatal", XS_Estraier_db_fatal, file);
        newXS("Estraier::db_add_attr_index", XS_Estraier_db_add_attr_index, file);
        newXS("Estraier::db_flush", XS_Estraier_db_flush, file);
        newXS("Estraier::db_sync", XS_Estraier_db_sync, file);
        newXS("Estraier::db_optimize", XS_Estraier_db_optimize, file);
        newXS("Estraier::db_merge", XS_Estraier_db_merge, file);
        newXS("Estraier::db_put_doc", XS_Estraier_db_put_doc, file);
        newXS("Estraier::db_out_doc", XS_Estraier_db_out_doc, file);
        newXS("Estraier::db_edit_doc", XS_Estraier_db_edit_doc, file);
        newXS("Estraier::db_get_doc", XS_Estraier_db_get_doc, file);
        newXS("Estraier::db_get_doc_attr", XS_Estraier_db_get_doc_attr, file);
        newXS("Estraier::db_uri_to_id", XS_Estraier_db_uri_to_id, file);
        newXS("Estraier::db_name", XS_Estraier_db_name, file);
        newXS("Estraier::db_doc_num", XS_Estraier_db_doc_num, file);
        newXS("Estraier::db_word_num", XS_Estraier_db_word_num, file);
        newXS("Estraier::db_size", XS_Estraier_db_size, file);
        newXS("Estraier::db_search", XS_Estraier_db_search, file);
        newXS("Estraier::db_scan_doc", XS_Estraier_db_scan_doc, file);
        newXS("Estraier::db_set_cache_size", XS_Estraier_db_set_cache_size, file);
        newXS("Estraier::db_add_pseudo_index", XS_Estraier_db_add_pseudo_index, file);
        newXS("Estraier::db_set_wildmax", XS_Estraier_db_set_wildmax, file);
        newXS("Estraier::db_set_informer", XS_Estraier_db_set_informer, file);
    if (PL_unitcheckav)
         call_list(PL_scopestack_ix, PL_unitcheckav);
    XSRETURN_YES;
}

